.data

	canvasRect	RECT <>
	szCanvasClass	db "CANVAS",0

.code
canvasRegister	PROC
LOCAL wc:WNDCLASSEX
		mov	wc.cbSize,sizeof WNDCLASSEX
		mov	wc.style,CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
		m2m	wc.lpfnWndProc,canvasProc
		mov	wc.cbClsExtra,NULL
		mov	wc.cbWndExtra,NULL
		m2m	wc.hInstance,hInstance
		mov	wc.hbrBackground,NULL
		mov	wc.lpszMenuName,NULL
		mov	wc.lpszClassName,offset szCanvasClass
		invoke LoadIcon,NULL,IDI_APPLICATION
		mov	wc.hIcon,eax
		invoke LoadCursor,NULL,IDC_CROSS
		mov	wc.hCursor,eax
		mov	wc.hIconSm,0
		invoke RegisterClassEx,ADDR wc

		ret

canvasRegister	ENDP

canvasCreate	PROC USES esi lpCanvas:PTR CANVAS

		mov	esi,lpCanvas
		ASSUME esi:PTR CANVAS

		invoke CreateWindowEx,WS_EX_STATICEDGE,
			offset szCanvasClass,NULL,
			WS_VISIBLE or WS_CHILD,
			[esi].x,[esi].y,[esi].w,[esi].h,
			[esi].hParent,[esi].ID,
			hInstance,NULL
		mov	[esi].hWnd,eax
		
		invoke SetWindowLong,eax,GWL_USERDATA,esi
		invoke SetWindowLong,[esi].hWnd,GWL_WNDPROC,[esi].lpWndProc
		ret
canvasCreate	ENDP

canvasProc	PROC hWnd:DWORD,uMsg:DWORD,wParam:WPARAM,lParam:LPARAM

;		.IF uMsg==WM_DESTROY
;			;
		.IF uMsg==WM_CREATE
			mov	eax,hWnd
			ret
		.ENDIF

		ret
canvasProc	ENDP

canvasDrawBack	PROC USES ebx esi edi hWnd:HWND,dwWidth:DWORD,dwXstep:DWORD,dwHeight:DWORD,dwYstep:DWORD

		invoke GetClientRect,hWnd,offset canvasRect

	; draw background
		invoke sDrawRect,0,0,canvasRect.right,canvasRect.bottom,COLOR_ACTIVE_BCKGRND

	; draw grid - using Bresenham line algorithm
	; vertical lines
		mov	eax,dwWidth		; dx
		xor	edx,edx
		mov	ecx,canvasRect.right
		div	dwXstep			; dy
		xor	ebx,ebx			; fraction is 0
		xchg	eax,ecx
		xor	edx,edx			; x0
		shl	ecx,1			; 2*dy
		shl	eax,1			; 2*dx
	@v1:
		cmp	ebx,0			; fraction >=0
		jnge @F
			sub	ebx,eax
			or	edx,edx
			jz @F
			invoke sDrawLineV,edx,0,canvasRect.bottom,COLOR_GRIDLINE
	@@:
		add	edx,1			; x0+=step
		add	ebx,ecx			; fraction+=dy
		cmp	edx,eax
		jnz @v1

	; horizontal lines
		mov	eax,dwHeight		; dx
		xor	edx,edx
		mov	ecx,canvasRect.bottom
		div	dwYstep			; dy
		xor	ebx,ebx			; fraction is 0
		xchg	eax,ecx
		xor	edx,edx			; x0
		shl	ecx,1			; 2*dy
		shl	eax,1			; 2*dx
	@h1:
		cmp	ebx,0			; fraction >=0
		jnge @F
			sub	ebx,eax
			or	edx,edx
			jz @F
			invoke sDrawLineH,0,edx,canvasRect.right,COLOR_GRIDLINE
	@@:
		add	edx,1			; x0+=step
		add	ebx,ecx			; fraction+=dy
		cmp	edx,eax
		jnz @h1

@End:
		ret
canvasDrawBack	ENDP
