.data

	filter1		REAL4 1000.0		; cutoff
			REAL4 0.0		; resonance
			dd 4			; filter order
			REAL4 0.0, 0.0009334988	; u4,b4
			REAL4 0.0, 0.0037339951	; u3,b3
			REAL4 0.0, 0.0056009926	; u2,b2
			REAL4 0.0, 0.0037339951	; u1,b1
			REAL4 0.0009334988	; b0,0
			;REAL4 0.0, 0.0		; 0,0
			;REAL4 0.0, 0.0		; 0,0
			;REAL4 0.0, 0.0		; 0,0
			REAL4 0.0, 0.35557738	; y4,a4
			REAL4 0.0, -1.7861066	; y3,a3
			REAL4 0.0, 3.4223096	; y2,a2
			REAL4 0.0, -2.9768443	; y1,a1
			REAL4 1.0		; a0,0
			;REAL4 0.0, 0.0		; 0,0
			;REAL4 0.0, 0.0		; 0,0
			;REAL4 0.0, 0.0		; 0,0

	dwFltXgrade	dd 10
	dwFltYgrade	dd 20
.data?
	hFilter		HWND ?

.code

filterDraw	PROC hWnd:DWORD,lpFlt:DWORD
	
	
		ret

filterDraw	ENDP

filterProc	PROC hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

		.IF uMsg == WM_CREATE
			m2m	hFilter,hWnd
		.ELSEIF uMsg == WM_PAINT
			invoke sdStart,hWnd
			or	eax,eax
			jz @Default
				invoke canvasDrawBack,hWnd,22000,dwFltXgrade,1000,dwFltYgrade
			invoke sdEnd
		.ENDIF
	@Default:
		xor	eax,eax
		ret
filterProc	ENDP

filterRun	PROC USES ebx edi esi lpFilter:DWORD

; y[k] = b0*u[k] + b1*u[k-1] + b2*u[k-2] + ... + bm*u[k-m] - a1*y[k-1] - a2*y[k-2] - ... - an*y[k-n]
; st(0): u[k]

		mov	esi,lpFilter
ALIGN 16
		mov	ecx,[esi+8]		; filter order
		fldz
		lea	edi,[esi+ecx*8+4+0Ch]	; y section
		add	esi,0Ch
		mov	ebx,[edi+8]		; prefetch y[k-i-1]
		mov	eax,[esi+8]		; prefetch u[k-i-1]
		
	; for (i=filter.m;i>0;i--)
	; {
	;	y+=filter.input[i].b*filter.input[i].u
	;	y-=filter.output[i].a*filter.output[i].y
	; }
	@@:

	; inputs
		fld	REAL4 PTR [esi]		; st: u[k-i]
		mov	[esi],eax		; u[k-i-1] -> u[k-i]
		fmul	REAL4 PTR [esi+4]	; st: bi*u[k-i]
		faddp	st(1),st
		add	esi,8
	; output feedbacks
		fld	REAL4 PTR [edi]		; st: y[k-i]
		mov	[edi],ebx		; y[k-i-1] -> y[k-i]
		fmul	REAL4 PTR [edi+4]	; st: ai*y[k-i]
		fsubp	st(1),st
		add	edi,8

		mov	eax,[esi+8]		; fetch u[k-i-1]
		mov	ebx,[edi+8]		; fetch y[k-i-1]
		sub	ecx,1
		jnz @B
	; y+=filter.b0*input[k]
	; filter.input[1].u=buffer[k]
		;fild	WORD PTR [edx]		; st: u[k]
		fxch	st(1)
		fst	REAL4 PTR [esi-8]
		fmul	REAL4 PTR [esi]		; st: b0*u[k]
		faddp	st(1),st
		fst	REAL4 PTR [edi-8]	; y[k]->y[k-1]

		add	dwFilterCycles,eax
		ret

filterRun	ENDP 