
.data
	szWF_SIN	db "sinus",0
	szWF_PLS	db "pulse",0
	szWF_PSAW	db "psaw",0
	szWF_IMP	db "imp",0
	szOscOnFormat	db "Osc%lu",0

	szR_NONE	db "none",0

	szR_FRE		db "fre",0
	szR_AMP		db "amp",0
	szR_PSW		db "psw",0

	freq1		POT <110.0,0.0,5000.0,100.0,4>
        freq2		POT <138.59131549,0.0,5000.0,100.0,4>
        freq3		POT <164.813778,0.0,5000.0,100.0,4>
        freq4		POT <329.6275569,0.0,5000.0,100.0,4>

	amp1		POT < 0.100,0.0, 1.0,0.01,3>
	amp2		POT < 0.060,0.0, 1.0,0.01,3>
	amp3		POT < 0.080,0.0,20.0,0.01,3>
	amp4		POT < 0.040,0.0,20.0,0.01,3>

	psw1		POT <1.0,0.0,1.0,0.05,3>
	psw2		POT <1.0,0.0,1.0,0.05,3>
	psw3		POT <1.0,0.0,1.0,0.05,3>
	psw4		POT <1.0,0.0,1.0,0.05,3>

	osc1		OSC <0.0, offset oscPSaw, 0.0, 0, <NULL,0.0>, <offset freq1,0.0>, <offset amp1,0.0>, <offset psw1,0.0>, 0, <100.0, -5000.0, 5000.0, 50.0, 2>, WF_PSAW,R_NONE,R_FRE,OSC_ON,0,NULL>
	osc2		OSC <0.0, offset oscPSaw, 0.0, 0, <NULL,0.0>, <offset freq2,0.0>, <offset amp2,0.0>, <offset psw2,0.0>, 0, <100.0, -5000.0, 5000.0, 50.0, 2>, WF_PSAW,R_NONE,R_FRE,OSC_ON,1,NULL>
	osc3		OSC <0.0, offset oscPSaw, 0.0, 0, <NULL,0.0>, <offset freq3,0.0>, <offset amp3,0.0>, <offset psw3,0.0>, 0, <100.0, -5000.0, 5000.0, 50.0, 2>, WF_PSAW,R_NONE,R_FRE,OSC_ON,2,NULL>
	osc4		OSC <0.0, offset oscPSaw, 0.0, 0, <NULL,0.0>, <offset freq4,0.0>, <offset amp4,0.0>, <offset psw4,0.0>, 0, <100.0, -5000.0, 5000.0, 50.0, 2>, WF_PSAW,R_NONE,R_FRE,OSC_ON,3,NULL>

	add1		ADD2 <0.0,NULL,<offset osc1,0.0>,<>>
	add2		ADD2 <0.0,NULL,<offset osc2,0.0>,<>>
	add3		ADD2 <0.0,NULL,<offset osc3,0.0>,<>>
	add4		ADD2 <0.0,NULL,<offset osc4,0.0>,<>>

	oscWaves	dd offset oscPSaw,offset oscPulse,offset oscSin,offset oscImp


.code

oscProc		PROC USES ebx esi edi hDlg:HWND,uMsg:DWORD,wParam:DWORD,lParam:DWORD
	
		.IF uMsg==WM_INITDIALOG
			mov	ebx,lParam
			lea	edx,[hPanel+ebx*4]
			m2m	[edx],hDlg
			imul	edx,ebx,size OSC
			add	edx,offset osc1
			invoke SetWindowLong,hDlg,GWL_USERDATA,edx
			imul	eax,ebx,DWORD PTR PANEL_OSC_H
			invoke MoveWindow,hDlg,0,eax,PANEL_OSC_W,PANEL_OSC_H,TRUE

		; init controls
		; set osc label
			add	ebx,1
			invoke wsprintf,lpStr,offset szOscOnFormat,ebx
			invoke SetDlgItemText,hDlg,IDC_ON,lpStr
		; set waveforms in combo box
			invoke SendDlgItemMessage,hDlg,IDC_WAVEFORM,CB_ADDSTRING,0,offset szWF_PSAW
			invoke SendDlgItemMessage,hDlg,IDC_WAVEFORM,CB_ADDSTRING,0,offset szWF_PLS
			invoke SendDlgItemMessage,hDlg,IDC_WAVEFORM,CB_ADDSTRING,0,offset szWF_SIN
			invoke SendDlgItemMessage,hDlg,IDC_WAVEFORM,CB_ADDSTRING,0,offset szWF_IMP
		; set route combo box
			invoke SendDlgItemMessage,hDlg,IDC_ROUTE,CB_ADDSTRING,0,offset szR_NONE
			xor	ecx,ecx
		@1:
			mov	eax,lParam
			cmp	ecx,eax
			jz @F
				push	ecx
				add	ecx,1
				invoke wsprintf,lpStr,offset szOscOnFormat,ecx
				invoke SendDlgItemMessage,hDlg,IDC_ROUTE,CB_ADDSTRING,0,lpStr
				pop	ecx
		@@:
			add	ecx,1
			cmp	ecx,4
			jc @1
		; set input combo box
			invoke SendDlgItemMessage,hDlg,IDC_INPUT,CB_ADDSTRING,0,offset szR_FRE
			invoke SendDlgItemMessage,hDlg,IDC_INPUT,CB_ADDSTRING,0,offset szR_AMP
			invoke SendDlgItemMessage,hDlg,IDC_INPUT,CB_ADDSTRING,0,offset szR_PSW


		; get osc object
			imul	edx,ebx,size OSC
			lea	ebx,[edx+offset osc1-size OSC]

		; get on status
			invoke enableOsc,ebx,hDlg
			mov	eax,BST_CHECKED
			cmp	(OSC PTR [ebx]).dwOn,0
			jnz @F
				mov	eax,BST_UNCHECKED
		@@:
			invoke CheckDlgButton,hDlg,IDC_ON,eax

		; get waveform
			cmp	(OSC PTR [ebx]).dwWaveform,WF_SIN
			jnz @F
				invoke SendDlgItemMessage,hDlg,IDC_PSW,WM_ENABLE,FALSE,0
		@@:
			invoke SendDlgItemMessage,hDlg,IDC_WAVEFORM,CB_SETCURSEL,(OSC PTR [ebx]).dwWaveform,0
		; get route
			invoke SendDlgItemMessage,hDlg,IDC_ROUTE,CB_SETCURSEL,(OSC PTR [ebx]).dwRouteMdl,0
			cmp	(OSC PTR [ebx]).dwRouteMdl,0
			jnz @F
				invoke GetDlgItem,hDlg,IDC_INPUT
				invoke EnableWindow,eax,FALSE
		@@:
			invoke SendDlgItemMessage,hDlg,IDC_INPUT,CB_SETCURSEL,(OSC PTR [ebx]).dwRouteInput,0

			mov	eax,(OSC PTR [ebx]).dwRouteMdl
			or	eax,eax
			jz @F
;				invoke oscRouting,ebx,1
		@@:
		; get freq
			push	esi
			imul	esi,(OSC PTR [ebx]).dwID,size POT
			lea	eax,[esi+freq1]
			push	eax
			invoke setFloatInput,hDlg,IDC_FREQ,NULL,eax
			pop	eax
			invoke displayValue,eax,hDlg,IDC_FREQ
		; get amp
			lea	eax,[esi+amp1]
			push	eax
			invoke setFloatInput,hDlg,IDC_AMP,NULL,eax
			pop	eax
			invoke displayValue,eax,hDlg,IDC_AMP
			;invoke getValue,eax
			;invoke R4toA,eax,lpStr,3
			;invoke SetDlgItemText,hDlg,IDC_AMP,lpStr
		; get psw
			lea	eax,[esi+psw1]
			push	eax
			invoke setFloatInput,hDlg,IDC_PSW,NULL,eax
			pop	eax
			invoke displayValue,eax,hDlg,IDC_PSW
			;invoke getValue,(OSC PTR [ebx]).psw.lpOutput
			;invoke R4toA,eax,lpStr,3
			;invoke SetDlgItemText,hDlg,IDC_PSW,lpStr			
			pop	esi
		; set scale
			lea	ecx,(OSC PTR [ebx]).scale.fValue
			push	ecx
			invoke setFloatInput,hDlg,IDC_SCALE,NULL,ecx
			pop	ecx
			invoke displayValue,ecx,hDlg,IDC_SCALE

			xor	eax,eax
		.ELSEIF uMsg==WM_COMMAND
			invoke GetWindowLong,hDlg,GWL_USERDATA
			mov	ebx,eax
			movzx	eax,WORD PTR [wParam]		; ctrlID
			movzx	ecx,WORD PTR [wParam+2]		; notification
			.IF eax==IDC_ON
				invoke SendDlgItemMessage,hDlg,eax,BM_GETCHECK,0,0
				.IF eax==BST_UNCHECKED
					xor	eax,eax
				.ENDIF
				mov	(OSC PTR [ebx]).dwOn,eax
				invoke enableOsc,ebx,hDlg
			.ELSEIF wParam==IDC_ROUTE+10000h*CBN_SELCHANGE
				invoke SendMessage,lParam,CB_GETCURSEL,0,0
				push	eax
				invoke GetDlgItem,hDlg,IDC_INPUT
				invoke EnableWindow,eax,[esp]
				invoke oscRouting,ebx,0
				pop	eax
				mov	(OSC PTR [ebx]).dwRouteMdl,eax
				.IF eax != 0
					invoke oscRouting,ebx,1
				.ENDIF
			.ELSEIF wParam==IDC_INPUT+10000h*CBN_SELCHANGE
				invoke SendMessage,lParam,CB_GETCURSEL,0,0
				push	eax
				invoke oscRouting,ebx,0
				pop	(OSC PTR [ebx]).dwRouteInput
				invoke oscRouting,ebx,1
				xor	eax,eax
			.ELSEIF eax==IDC_WAVEFORM
				invoke SendMessage,lParam,CB_GETCURSEL,0,0
				mov	(OSC PTR [ebx]).dwWaveform,eax
				mov	ecx,[oscWaves+eax*4]
				mov	(OSC PTR [ebx]).lpRun,ecx

				mov	edx,FALSE
				cmp	eax,WF_SIN
				jz @wf1
				cmp	eax,WF_IMP
				jz @wf1
					mov	edx,TRUE
			@wf1:
				push	edx
				invoke GetDlgItem,hDlg,IDC_PSW
				invoke EnableWindow,eax,[esp]
				add	esp,4
				xor	eax,eax
			.ELSE
				xor	eax,eax
				;mov	eax,1
			.ENDIF

		.ELSEIF uMsg==WM_CLOSE
			invoke EndDialog,hDlg,NULL
		.ELSE
			xor	eax,eax
		.ENDIF

		ret

oscProc		ENDP

oscRouting	PROC USES ebx edi esi lpOsc:DWORD,mode:BOOL

		mov	esi,lpOsc
		ASSUME esi:PTR OSC
		mov	ebx,[esi].dwID				; osc's ordinal
		mov	ecx,[esi].dwRouteMdl			; route target module
		mov	edx,[esi].dwRouteInput			; target gate of module
	; get add element
		mov	edi,offset add1
		imul	eax,ebx,size ADD2
		add	edi,eax					; assigned add2 module
	; get modulated osc and input
		cmp	mode,0
		jnz @F
		or	ecx,ecx
		jz @End
		; routing disabled
			mov	edx,(ADD2 PTR [edi]).lpInput
			or	edx,edx
			jz @End
			mov	eax,(ADD2 PTR [edi]).op2.lpOutput	; get original input
;			mov	(ADD2 PTR [edi]).lpInput,0
			mov	(ADD2 PTR [edi]).op2.lpOutput,0
			jmp @1
	@@:	; routing enabled
			cmp	ecx,ebx
			ja @F
				sub	ecx,1
		@@: 
			imul	eax,ecx,size OSC
			lea	edx,[osc1+eax+edx*8+OSC.fre]		; modulated input
			mov	eax,edi
			push	(GATE PTR [edx]).lpOutput
			mov	(ADD2 PTR [edi]).lpInput,edx
			pop	(ADD2 PTR [edi]).op2.lpOutput		; original routed value (POT.fValue)
;PrintHex eax,'en'
	@1:
		mov	(GATE PTR [edx]).lpOutput,eax		; route!
@End:
;mov	eax,add1.op1.lpOutput
;PrintHex eax,'add1.op1'
;mov	eax,add1.op2.lpOutput
;PrintHex eax,'add1.op2'
		ret
		ASSUME esi:NOTHING
oscRouting	ENDP


oscPSaw		PROC lpOsc:DWORD
LOCAL dwPSW:DWORD

		mov	esi,lpOsc
		ASSUME esi:PTR OSC
	; calculate pulse width and amplitude
		mov	eax,[esi].amp.lpOutput
		fld	(POT PTR [eax]).fValue
		mov	eax,[esi].psw.lpOutput
		fld	(POT PTR [eax]).fValue
		fmul	REAL4 PTR fSampleRate
	;mov	edi,lpBufferGenPos
		fist	[esi].dwPsw
		fxch	st(1)

		fld	[esi].fCounter
ALIGN 4
	@psaw1:
	; st(0): counter
	; st(1): amp
	; st(2): psw
		fcom	st(2)
		fstsw	ax
		sahf
		jnc @F
			fld	st			; counter
			fmul	REAL4 PTR f2		; counter*2
			fmul	st,st(2)		; counter*2*amp
			fdiv	st,st(3)		; (counter*2*amp)/psw
			fsub	st,st(2)		; counter*2*amp/psw
			jmp @psaw2
	@@:
		fld	st(1)				; load amp		
	@psaw2:
	; st(0): sample
	; st(1): counter
	; st(2): amp
	; st(3): psw
			;invoke getEnvelope,offset Envelope1
			;fmul	REAL4 PTR fMaxAmp	; scale...
			.IF [esi].dwRouteMdl != 0
				fmul	[esi].scale.fValue
			.ENDIF
			fstp	[esi].fValue
		;fistp	WORD PTR [edi]		; ...and store sample
		mov	eax,[esi].fre.lpOutput
		fadd	(POT PTR [eax]).fValue
		fcom	REAL4 PTR fSampleRate
	;add	edi,2
		fstsw	ax
		sahf
		jc @F
			fsub	REAL4 PTR fSampleRate
	@@:
		;sub	ecx,1
		;jnz @psaw1
		fstp	[esi].fCounter
		fstp	st
		fstp	st
@End:
		ret
		ASSUME esi:NOTHING
oscPSaw		ENDP

oscPulse	PROC lpOsc:DWORD
LOCAL dwPSW:DWORD

		mov	esi,lpOsc
		ASSUME esi:PTR OSC
	; calculate pulse width and amplitude
		mov	eax,[esi].psw.lpOutput
		fld	fSampleRate
		mov	ecx,[esi].amp.lpOutput
		fmul	(POT PTR [eax]).fValue		; pswsmp=pulsew*sampleRate
		;fist	[esi].dwPsw
		fld	(POT PTR [ecx]).fValue
		fld	[esi].fCounter
	; st(0): counter
	; st(1): amp
	; st(2): pswsmp
		fcom	st(2)
		fstsw	ax
		sahf
		fxch	st(1)
		jc @F
			fchs
	@@:
	; st(0): amp
	; st(1): counter
	; st(2): pswsmp	
			;invoke getEnvelope,offset Envelope1
		mov	eax,[esi].fre.lpOutput
		.IF [esi].dwRouteMdl != 0
			fmul	[esi].scale.fValue
		.ENDIF		
		fstp	[esi].fValue
		fadd	(POT PTR [eax]).fValue
		fcom	fSampleRate
		fstsw	ax
		sahf
		jc @F
			fsub	fSampleRate
	@@:
		fstp	[esi].fCounter
		fstp	st
@End:
		ret
		ASSUME esi:NOTHING
oscPulse	ENDP

oscSin		PROC lpOsc:DWORD

		mov	esi,lpOsc
		ASSUME esi:PTR OSC
		mov	eax,[esi].amp.lpOutput
		fld	[esi].fCounter
		fld	(POT PTR [eax]).fValue
		fld	st(1)
	; st(0): counter
	; st(1): amp
	; st(2): counter
		fsin
		mov	eax,[esi].fre.lpOutput
			fmulp	st(1),st
			;invoke getEnvelope,offset Envelope1
			.IF [esi].dwRouteMdl != 0
				fmul	[esi].scale.fValue
			.ENDIF
			fstp	[esi].fValue
		fld	(POT PTR [eax]).fValue
		fmul	fW
		faddp	st(1),st
		fcom	f2PI
		;add	edi,2
		fstsw	ax
		sahf
		jc @F
			fsub	REAL4 PTR f2PI
	@@:
		;sub	ecx,1
		;jnz @sin1
		fstp	[esi].fCounter
		ret
		ASSUME esi:NOTHING
oscSin		ENDP

oscImp		PROC lpOsc:DWORD

		mov	esi,lpOsc
		ASSUME esi:PTR OSC
		mov	ecx,[esi].amp.lpOutput
		
		mov	edx,[esi].fre.lpOutput
		fld	[esi].fCounter
		fcom	(POT PTR [edx]).fValue
		fstsw	ax
		sahf
		fld	(POT PTR [ecx]).fValue
		ja @F
			fchs
	@@:
		.IF [esi].dwRouteMdl != 0
			fmul	[esi].scale.fValue
		.ENDIF
		fstp	[esi].fValue

		fadd	(POT PTR [edx]).fValue
		fcom	fSampleRate
		fstsw	ax
		sahf
		jc @F
			fsub	fSampleRate
			fchs
	@@:
		fstp	[esi].fCounter
@End:
		ret	
		ASSUME esi:NOTHING
oscImp		ENDP


oscDraw		PROC hWnd:DWORD,lpOsc:PTR OSC

		ret
oscDraw		ENDP

enableOsc	PROC lpOsc:PTR OSC,hDlg:HWND
		mov	ecx,lpOsc
		push	(OSC PTR [ecx]).dwOn
		invoke GetDlgItem,hDlg,IDC_WAVEFORM
		invoke EnableWindow,eax,[esp]
		;invoke SendDlgItemMessage,hDlg,IDC_WAVEFORM,WM_ENABLE,DWORD PTR [esp+4],0
		invoke GetDlgItem,hDlg,IDC_ROUTE
		invoke EnableWindow,eax,[esp]
		;invoke SendDlgItemMessage,hDlg,IDC_INPUT,WM_ENABLE,DWORD PTR [esp+4],0
		invoke SendDlgItemMessage,hDlg,IDC_FREQ,WM_ENABLE,DWORD PTR [esp+4],0
		invoke SendDlgItemMessage,hDlg,IDC_AMP,WM_ENABLE,DWORD PTR [esp+4],0
		invoke SendDlgItemMessage,hDlg,IDC_PSW,WM_ENABLE,DWORD PTR [esp+4],0
		invoke SendDlgItemMessage,hDlg,IDC_ROUTE,WM_ENABLE,DWORD PTR [esp+4],0
		cmp	DWORD PTR [esp],0
		jz @F
			invoke SendDlgItemMessage,hDlg,IDC_ROUTE,CB_GETCURSEL,0,0
			.IF !eax
				mov	DWORD PTR [esp],0
			.ENDIF
	@@:
		;invoke SendDlgItemMessage,hDlg,IDC_ROUTE,WM_ENABLE,DWORD PTR [esp+4],0
		invoke GetDlgItem,hDlg,IDC_INPUT
		invoke EnableWindow,eax,[esp]

		add	esp,4
		ret
enableOsc	ENDP
