; 
;
; MDL CLASS
;
; Virtual base class
;
; 


IFNDEF SSN_MDL_CLID

	SSN_MDL_CLID		EQU 0FFFFh

; Extern symbols
	EXTERNDEF	lpStr:DWORD

; Module symbols



MDL_CLASS	STRUCT	; MDL class structure

		_vft		LPVFT ?				; virtual function table
; Private properties
		lpRun		LPRUN ?
		fSmp		SAMPLE ?			; holds actual sample value
		dwType		dd ?				; module's type for run-time type check
		dwID		dd ?				; id of module
; Public properties
		lpParent	dd ?				; pointer to parent object
		szID		db 12 dup (?)			; label of module
		szNotation	db 64 dup (?)			; comment

; Virtual functions
		MDL_constructor		PROTO CONSTRUCTOR	; PROTO dwType:DWORD
		MDL_destructor		PROTO DESTRUCTOR	;
		MDL_build		PROTO BUILD		; lpBinData:DWORD
		MDL_buildFromXML	PROTO BUILDFROMXML	; lpXMLnode:DWORD
		MDL_export		PROTO EXPORT		; lpBinData:DWORD
		MDL_exportToXML		PROTO EXPORTTOXML	; lpXMLnode:DWORD
		MDL_connect		PROTO CONNECT		; dwGate:DWORD,lpFloat:DWORD
		MDL_disconnect		PROTO DISCONNECT	; dwGate:DWORD
		MDL_getInput		PROTO GETINPUT		; dwID:DWORD
		MDL_getOutput		PROTO GETOUTPUT		; dwID:DWORD
		MDL_info		PROTO INFO		; lpStr:DWORD
		MDL_reset		PROTO RESET
		MDL_run			PROTO RUN
; Methods
		MDL_setID		PROTO lpszID:DWORD
		MDL_getID		PROTO lpszID:DWORD
		MDL_setNotation		PROTO lpszNotation:DWORD
		MDL_getNotation		PROTO lpszNotation:DWORD
		MDL_setSmp		PROTO lpSample:PTR SAMPLE
		MDL_getSmp		PROTO lpSample:PTR SAMPLE
		MDL_setParent		PROTO lpMdl:DWORD
		MDL_getParent		PROTO

MDL_CLASS	ENDS

ENDIF

GATE		STRUCT
; Structure for representing a gate, receiver of signals

		lpOutput	dd ?			; pointer to an output
		fValue		SAMPLE ?		; copy of output for caching

GATE		ENDS

GATE2		STRUCT
; Gate with previous state for slope detection

				GATE <>
		dwPrevValue	DWORD ?		; the output in the previous cycle

GATE2		ENDS

MDL_ResetGate	MACRO Gate:REQ,isGate2:=<FALSE>
; Reset routing pointer, cleare cached data

	; set gate's pointer to dumyOutput
		lea	edx,[ecx+Gate]
		mov	eax,offset fZero
		mov	(GATE PTR [edx]).lpOutput,eax
	; set the value to zero
		SETSAMPLE (GATE PTR [edx]).fValue,fZero
		IF isGate2 EQ 1
	; set the oldValue to zero
			mov (GATE2 PTR [edx]).dwPrevValue,0
		ENDIF

ENDM


MDL_SlopeUp	MACRO Gate
; al: input(k)
; dl: input(k-1)
;  if (input > 0) then 0 else 1
; dl\al 0 1
;   0   0 0
;   1   1 0
; out=!al and dl

		MDL_UpdateGate Gate
		jz @F

		mov	al,BYTE PTR [[ecx].Gate.fValue+size SAMPLE-1]
		mov	dl,BYTE PTR [[ecx].Gate.dwPrevValue]
		shr	al,7
		mov	BYTE PTR [[ecx].Gate.dwPrevValue],al				; store prev value
		not	al			; !al
		and	dl,al			; !al and dl
	@@:
; z=0 - slope up
; z=1 - no slope event	

ENDM

MDL_SlopeDown	MACRO Gate
; al: input(k)
; dl: input(k-1)
;  if (input > 0) then 0 else 1
; dl\al 0 1
;   0   0 1
;   1   0 0
; out=al and !dl
		MDL_UpdateGate Gate
		jz @F

		mov	al,BYTE PTR [[ecx].Gate.fValue+size SAMPLE-1]
		mov	dl,BYTE PTR [[ecx].Gate.dwPrevValue]
		shr	al,7
		not	dl			; !dl
		mov	BYTE PTR [[ecx].Gate.dwPrevValue],al				; store prev value
		and	dl,al			; al and !dl
	@@:
; z=0 - slope down
; z=1 - no slope event
ENDM

UpdateGateR4	MACRO Gate
	
		mov	edx,[ecx].Gate.lpOutput
		mov	eax,[edx]				; get R4 value
		cmp	eax,DWORD PTR [ecx].Gate.fValue
		jz @F
			mov	DWORD PTR [ecx].Gate.fValue,eax
	@@:
; z=0 - value changed and updated
; z=1 - no update (no change in routed output)
ENDM

		MDL_UpdateGate	TEXTEQU <UpdateGateR4>